<?php
/**
* category.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$category_typ["attributes"]["allowAd"] =  
            array(
                "type"=>"INT",
                "bool",
                "default"=>"1"
            );
$category_typ["attributes"]["description"] =  
            array(
                "type"=>"TEXT",
                "textarea",
                "rows"=>5,
                "cols"=>50,
                "details",
            );
$category_typ["attributes"]["picture"] =  
            array(
                "type"=>"VARCHAR",
                "file",
                "max" =>"250"
             );
$category_typ["attributes"]["accessview"] =
			array(
				"type"=>"INT",
				"access_selection",
				"default"=>"0",
			);
$category_typ["attributes"]["accesspost"] =
			array(
				"type"=>"INT",
				"access_selection",
				"default"=>"1",
				);
				
class classifiedscategory extends category
{

function create($overrulePrivilege=FALSE)
{
    global $lll, $whatHappened;   
     
    category::create($overrulePrivilege);
    if( $whatHappened=="form_submitted" )
    {
        // Letrehozunk hozza egy varfields objektumot azonos id-vel:
        $varfields = new varfields;
        if( $this->up ) // az apa varfieldsei oroklodnek a gyerekbe
        {
            $varfields->id = $this->up;
            load($varfields);
        }
        else
        {
            $varfields->name_0=$lll["descriptionDefaultLabel"];
            $varfields->type_0=varfields_textarea;
            $varfields->active_0=TRUE;
            $varfields->everActivated_0=TRUE;
            $varfields->list_0=TRUE;
            $varfields->searchable_0=TRUE;
            $varfields->badwords_0=TRUE;
            $varfields->innewline_0=TRUE;
        }
        $varfields->id = $this->id;
        $varfields->create();
        
        $this->storeAttachment();
    }
} 

function modify( $whereFields="", $overrulePrivilege=FALSE )
{
    global $recursive, $whatHappened;
    
    if( isset($recursive) && $recursive )
    {
        category::modify($whereFields,$overrulePrivilege);        
        return;
    }
    category::modify($whereFields,$overrulePrivilege);        
    if( $whatHappened=="form_submitted" )
    {
        $this->storeAttachment();
    }    
}

function delete( $whereFields="", $overrulePrivilege=FALSE )
{
    global $infoText,$lll, $catAttLocalDir;

    category::delete($whereFields,$overrulePrivilege);
    if( $this->picture )
    {
        $ret=@unlink("$catAttLocalDir/$this->id".".".$this->picture);
        if(!$ret) $infoText=sprintf($lll["cantdelfile"],$this->picture);
    }
    
    // Kitoroljuk az azonos id-ju varfields objektumot is:
    $varfields = new varfields;
    $varfields->id = $this->id;
    delete($varfields);
}

function showNavBar($withLink=FALSE)
{
    global $gorumroll, $lll, $categoryClassName;

    $s="";
    if (!$gorumroll->rollid) {
        //$s.=$lll["cat_main_tit"];
        return $s;
    }
    $tempRoll = clone($gorumroll);
    $tempRoll->list = $categoryClassName;
    $tempRoll->method = "showhtmllist";
    $tempRoll->rollid=0;
    $s.=$tempRoll->generAnchor($lll["home"], "navBar");
    
    $this->cacheFatherObjects();
    global $fatherCatList;

    foreach( $fatherCatList as $fatherCat )
    {
        if( $fatherCat->id!=$this->id )
        {
            $s.="&nbsp;>&nbsp;";
            $tempRoll = clone($gorumroll);
            $tempRoll->list=$categoryClassName;
            $tempRoll->method="showhtmllist";
            $tempRoll->rollid=$fatherCat->id;
            $s.=$tempRoll->generAnchor(
                htmlspecialchars($fatherCat->name),"navBar");
        }    
    }
    $s.="&nbsp;>&nbsp;";
    if( $gorumroll->method=="showhtmllist" )
    {
        $s.="<span class='navBar'>";
        $s.=htmlspecialchars($this->name);
        $s.="</span>";
    }
    else
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list=$categoryClassName;
        $tempRoll->method="showhtmllist";
        $tempRoll->rollid=$this->id;
        $s.=$tempRoll->generAnchor(
            htmlspecialchars($this->name),"navBar");
    }
    return $s;
} 
   
function showHtmlList(&$s)
{
    global $gorumroll,$lll,$methodsInHead,$colspNum;
    global $catAttDir, $categoryClassName, $itemClassName;
	global $noahSet;

    $s="";
    $this->id = $gorumroll->rollid;
    // Ha ilyen-olyan torlesi kavarasok kovetkezteben ez az objektum
    // mar nem letezik, akkor a home-ra megyunk:
    if( load($this) ) $gorumroll->rollid=0;
    $this->loadHtmlList($list);
    $this->hasGeneralRights($rights);
    hasAdminRights($isAdm);
    $rangeSelText = "";
    $catArr = array();
    $i=0;
    foreach( $list as $listItem ) {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $categoryClassName;
        $tempRoll->method = "showhtmllist";
        $tempRoll->rollid = "$listItem->id";
        saveInFromFrom($tempRoll);
        $catText=$tempRoll->generAnchor(
           htmlspecialchars($listItem->name));
        $catArr[$i]->title=$catText;
        $catArr[$i]->description=$listItem->description;
        $catArr[$i]->itemNum=$listItem->itemNum;
        if( $listItem->picture ) {
            $picName = "$catAttDir/$listItem->id".".".
                       "$listItem->picture";
            $picLink=$tempRoll->generImageAnchor($picName,
                                                 $listItem->name);
            $catArr[$i]->pic=$picLink;
        }
        else {
            $catArr[$i]->pic="";
        }
        $i++;
    }
    $msgAdd = "";
    if( $gorumroll->rollid && $this->allowAd ) // Home-ban nem kell
    {
		global $my;
		
		$adListStr = "";
		if (!$isAdm && $my->gid < $this->accessview) {
			// Handle no access to view these ads
			
			if ($noahSet->noviewingmsg != "") {
				$msgAdd = "<p>" . $noahSet->noviewingmsg . "</p>";
			}
		} else {
			$s.="<p>\n";
			//Advertisement htmllist - BEGIN
			$gorumroll->list = $gorumroll->class = $itemClassName;
			$gorumroll->generallist = $categoryClassName;
			//$gorumroll->generalrollid = $gorumroll->rollid;
			$advertisement = new $itemClassName;
			$advertisement->cid = $gorumroll->rollid;
			$advertisement->showHtmlList($adListStr);
			$gorumroll->list = $gorumroll->class = $categoryClassName;
			//$gorumroll->rollid = $gorumroll->generalrollid;
			//$s.=$s1;
		}
    }
    else $adListStr="";
    if ($gorumroll->rollid) $diffCols=FALSE;
    else $diffCols=TRUE;
    $s=$msgAdd . templateShowCat($catArr,$adListStr,$diffCols);
    //Advertisement htmllist - END
} 

function valid()
{
    global $lll;
    global $infoText, $whatHappened;
    
    if (!isset($_FILES["picture"]["name"]) ||
        $_FILES["picture"]["name"]=="")
    {
        return category::valid();
    }
    if (isset($_FILES["picture"]["name"]) &&
        strstr($_FILES["picture"]["name"]," "))
    {
        $whatHappened = "invalid_form";
        $infoText = $lll["spacenoatt"];
        return ok;
    }
    if ($_FILES["picture"]["size"]==0) {
        $infoText=$lll["picFileSizeNull"];
        $whatHappened = "invalid_form";
        return ok;
    }
    if ($_FILES["picture"]["tmp_name"]=="none") {
        $infoText=$lll["picFileSizeToLarge1"];
        $whatHappened = "invalid_form";
        return ok;
    }
    if (!is_uploaded_file( //ONLY from php 4.02 !!!
            $_FILES["picture"]["tmp_name"]))
    {
        handleError("Possible attack");
    }
    $fname=$_FILES["picture"]["tmp_name"];
    $size = getimagesize( $fname );
    if (!$size) {
        $infoText=$lll["notValidImageFile"];
        $whatHappened = "invalid_form";
        return ok;
    }
    return category::valid();
}

function storeAttachment()
{
    global $whatHappened, $lll, $infoText;
    global $catAttLocalDir, $categoryClassName, $applName;

    if (!isset($_FILES["picture"]["name"]) ||
        $_FILES["picture"]["name"]=="")
    {
        return ok;
    }
    $fname=$_FILES["picture"]["tmp_name"];
    $f=@fopen($fname,"r");
    if (!$f) {
        $infoText = $lll["cantOpenFile"];
        return ok;
    }
    $extensions = array("", "gif", "jpg", "png");
    //$checkBits = array(0, IMG_GIF, IMG_JPG, IMG_PNG);
    $size = getimagesize( $fname );
    $type = $size[2]; // az image tipus, 1=>GIF, 2=>JPG, 3=>PNG
    // ha az adott image tipus supportalva van:
    $file = fread($f,$_FILES["picture"]["size"]);
    $ext = $extensions[$type];
    $foname = "$catAttLocalDir/$this->id".".".$ext;
    $fo = fopen($foname,"w");
    //TODO: error handle
    fwrite( $fo,$file);
    fclose( $fo );
    // A picture-ben csak azt taroljuk el, hogy mi a kiterjesztes:
    $query = "UPDATE $applName"."_$categoryClassName SET picture='$ext'".
             " WHERE id=$this->id";
    executeQuery( $query );
    $_FILES["picture"]["name"]="";
    return ok;
}

// Ez azert kell, mert a catregory listben egy kategory list es egy 
// ad list is van, de a lapozo toolnak csak az ad listre kell 
// vonatkoznia
function getLimit()
{
    return "";
}   

}
?>
