<?php
/**
* dbupgrade.noah.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// Contains the routine to upgrade the database tables.

function Noah_FUpgradeDatabaseTables(&$msg) {
	global $database;

	$fError = false;
	
	$msg = "";
		
	// Deal with upgrade issues
	
	// .5, .6 alpha => .8 beta
	// Need to add new columns to the settings table
	
	if (!NoahAds_addFieldToTable('settings_guestreplyto', "#__classifieds_globalsettings", "TINYINT NOT NULL DEFAULT '0'")) {
		$fError = true;
		$msg .= "Error upgrading settings table (guestreplyto). ";
	}
	
	if (!NoahAds_addFieldToTable('settings_guestemailfriend', "#__classifieds_globalsettings", "TINYINT NOT NULL DEFAULT '0'")) {
		$fError = true;
		$msg .= "Error upgrading settings table (guestemailfriend). ";
	}

	if (!NoahAds_addFieldToTable('settings_graphicsLib', "#__classifieds_globalsettings", "TINYINT NOT NULL DEFAULT '0'")) {
		$fError = true;
		$msg .= "Error upgrading settings table (graphicsLib). ";
	}

	if (!NoahAds_addFieldToTable('settings_graphicsPath', "#__classifieds_globalsettings", "VARCHAR(255) NOT NULL default ''")) {
		$fError = true;
		$msg .= "Error upgrading settings table (graphicsPath). ";
	}

	$stQuery = "CREATE TABLE IF NOT EXISTS `#__noahads_settings` ("
				."\n `numfields` int(11) NOT NULL default '10' "
				. "\n ) TYPE=MyISAM";
				
	$database->setQuery($stQuery);
	if ($database->query() === false) {
		$fError = true;
		$msg .= "Error adding new settings table. ";
	}

	$stQuery = "SELECT numfields FROM `#__noahads_settings` LIMIT 1";
	
	$database->setQuery($stQuery);
	
	if ($database->query() === false) {
		$fError = true;
		$msg .= "Error looking at noahads_settings.";
	}
	
	$value = $database->loadResult();
	
	if ($value === null) {
		// Add one settings row
		$stQuery = "INSERT INTO `#__noahads_settings` (numfields) VALUES "
				. "\n (10)";	
		$database->setQuery($stQuery);
		if ($database->query() === false) {
			$fError = true;
			$msg .= " Error adding basic settings to noahads_settings table.<br/>";
		}
		
	}

	$rgNewFields = array( 
					// Beta 1 to Beta 2
					array('payclasspath', "#__noahads_settings", "varchar(100) NOT NULL default ''", " Error adding payclasspath to noahads_settings.<br/>"),
					array('paystatus', "#__classifieds_advertisement", "int(11) NOT NULL default '1'", " Error adding paystatus to classifieds_advertisement.<br/>"),
					// Beta 2 to Beta 3
					array('nopostingmsg', '#__noahads_settings', "varchar(200) NOT NULL default ''", " Error adding nopostingmsg to noahads_settings.<br/>"),
					array('noviewingmsg', '#__noahads_settings', "varchar(200) NOT NULL default ''", " Error adding noviewingmsg to noahads_settings.<br/>"),
					array('accesspost', '#__classifieds_classifiedscategory', "int(11) NOT NULL default '1'", " Error adding accesspost to classifieds_classifiedscategory.<br/>"),
					array('accessview', '#__classifieds_classifiedscategory', "int(11) NOT NULL default '0'", " Error adding accessview to classifieds_classifiedscategory.<br/>"),
					);
					
	foreach ($rgNewFields as $newField) {
		if (!NoahAds_addFieldToTable($newField[0], $newField[1], $newField[2])) {
			$fError = true;
			$msg .= $newField[3];
		}
	}
					
	if (!updateNewVariableFields($database, "owneradminonly", "tinyint(3) unsigned NOT NULL default '0'", "private")) {
		$msg .= " Error adding owneradminonly to varfields";
		$fError = true;
	}

	return !$fError;
}

function updateNewVariableFields(&$db, $stField, $stAttribs, $stFieldAfter="") {
	
	global $applName;

	// Find how many, if any, of this field exist	
	$stQuery = "SHOW COLUMNS FROM #__classifieds_varfields LIKE '{$stField}_%'";
	$db->setQuery($stQuery);
	
	$rgFields = $db->loadResultArray();
	
	if ($rgFields == null) {
		$iFieldsCur = 0;
	} else {
		$rgNums = str_replace("{$stField}_", "", $rgFields);
		sort($rgNums);
		
		$iFieldsCur = count($rgNums);
		
		if ($rgNums[$iFieldsCur - 1] != ($iFieldsCur - 1) ) {
			// We should never hit this.
			echo "<font color='red'>WARNING: #__classifieds_varfields is inconsistant</font>";
			return false;
		}
	}

	// Find how many varfields we have currently.	
	$stQuery = "SHOW COLUMNS FROM #__classifieds_varfields LIKE 'name_%'";
	$db->setQuery($stQuery);
	
	$rgFields = $db->loadResultArray();
	
	$rgNums = str_replace("name_", "", $rgFields);
	sort($rgNums);
	
	$iFields = count($rgNums);
	
	if ($rgNums[$iFields - 1] != ($iFields - 1) ) {
		// We should never hit this.
		echo "<font color='red'>WARNING: #__classifieds_varfields is inconsistant</font>";
		return false;
	}
	
	for ($i = $iFieldsCur ; $i < $iFields ; $i++) {
		$stQuery = "ALTER TABLE #__classifieds_varfields ADD "
			. "\n `{$stField}_$i` $stAttribs";
			
		if ($stFieldAfter != "") {
			$stQuery .= " AFTER `{$stFieldAfter}_$i`";
		}
		
		$db->setQuery($stQuery);
		if ($db->query() === false) {
			return false;
		}

	} 
	
	return true;
}

/**
 * 
 * Updates the number of variables allowed
 */
function updateVariableTables(&$db, $numFieldsNew) {
	global $applName;
	
	$stQuery = "SHOW COLUMNS FROM #__classifieds_varfields LIKE 'name_%'";
	$db->setQuery($stQuery);
	
	$rgFields = $db->loadResultArray();
	
	$rgNums = str_replace("name_", "", $rgFields);
	sort($rgNums);
	
	$iFields = count($rgNums);
	
	if ($rgNums[$iFields - 1] != ($iFields - 1) ) {
		// We should never hit this.
		echo "<font color='red'>WARNING: #__classifieds_varfields is inconsistant</font>";
		return false;
	}
	
	if ($numFieldsNew > $iFields) {
		// Add new fields
		for ($i = $iFields ; $i < $numFieldsNew ; $i++) {
			$stQuery = "ALTER TABLE #__classifieds_varfields ADD ("
				. "\n `name_$i` varchar(120) NOT NULL default '', "
				. "\n `type_$i` int(11) NOT NULL default '1', "
				. "\n `active_$i` int(11) NOT NULL default '0', "
				. "\n `everActivated_$i` int(11) NOT NULL default '0', "
				. "\n `values_$i` text NOT NULL, "
				. "\n `default_$i` text NOT NULL, "
				. "\n `mandatory_$i` int(11) NOT NULL default '0', "
				. "\n `list_$i` int(11) NOT NULL default '0', "
				. "\n `innewline_$i` int(11) NOT NULL default '0', "
				. "\n `searchable_$i` int(11) NOT NULL default '0', "
				. "\n `badwords_$i` int(11) NOT NULL default '0', "
				. "\n `allowHtml_$i` int(11) NOT NULL default '0', "
				. "\n `private_$i` int(11) NOT NULL default '0', "
				. "\n `owneradminonly_$i` tinyint NOT NULL default '0', "
				. "\n `hidden_$i` int(11) NOT NULL default '0', "
				. "\n `format_$i` varchar(255) NOT NULL default '' )";
				
			$db->setQuery($stQuery);
			if ($db->query() === false) {
				return false;
			}
		}

	} 
		
	$stQuery = "SHOW COLUMNS FROM #__classifieds_advertisement LIKE 'col_%'";
	$db->setQuery($stQuery);
	
	$rgFields = $db->loadResultArray();
	
	$rgNums = str_replace("col_", "", $rgFields);
	sort($rgNums);
	
	$iFields = count($rgNums);
	
	if ($rgNums[$iFields - 1] != ($iFields - 1) ) {
		// We should never hit this.
		echo "<font color='red'>WARNING: #__classifieds_advertisement is inconsistant</font>";
		return false;
	}
	
	if ($numFieldsNew > $iFields) {
		for ($i = $iFields ; $i < $numFieldsNew ; $i++) {
			$stQuery = "ALTER TABLE #__classifieds_advertisement ADD ("
				. "\n `col_$i` text NOT NULL )";
				
			$db->setQuery($stQuery);
			if ($db->query() === false) {
				return false;
			}
		}		
	}
	return true;
}

/**
 * @package NoahClassifieds
 * @subpackage install
 * @param string field to add
 * @param string table to add to
 * @param string properties of the field
 *
 * Checks to see if the field is already in the table and if not
 * adds it
 */
function NoahAds_addFieldToTable($fieldName, $tableName, $fieldProps) {
	global $database;
	
	$stQuery = "SHOW COLUMNS FROM `$tableName` LIKE '$fieldName'";
	$database->setQuery($stQuery);
	
	$stField = $database->loadResult();

	if ($stField == null) {
		$stUpdate = "ALTER TABLE `$tableName` ADD ("
				. "\n `$fieldName` $fieldProps )";
				
		$database->setQuery($stUpdate);
		if ($database->query() === false) {
			echo $database->getErrorMsg();
			return false;
		}		
	}
	return true;
}

?>