<?php
/**
* dbproperty.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function executeQuery($query,$file="",$line="") 
{   
	global $database;
	
	$database->setQuery($query);
	$result = $database->query();
    if( $result===false ) {
        handleError("mysql",$query,$file,$line);
    }
    return $result;
}

function loadSQL( &$base, $query="") 
{   
    global $applName;
    global $database;
    
    if( $query=="" ) {
        $query = "SELECT * FROM $applName"."_".get_class($base);
        //TODO: default order by nem kellene?
    }
    $database->setQuery($query);
    if (!$database->loadObject($row)) {
        return not_found_in_db;
    }
    $base->initFromObj( $row );
    return ok;
}

function loadObjectsSQL( $base, $query="",&$objArr) 
{   
    global $applName;
    global $database;
    
    $objArr = array();
    $className=get_class($base);
    if( $query=="" ) {
        $query = "SELECT * FROM $applName"."_$className";
        //TODO: order by?
    }
    $database->setQuery($query);
    $rgRows = $database->loadObjectList();
    if ($rgRows == null) {
        return not_found_in_db;
    }
    $num = count($rgRows);
    if ($num==0) {
        return not_found_in_db;
    }
		
    for($i=0;$i<$num;$i++) {
        $objArr[$i] = new $className;
        $objArr[$i]->initFromObj($rgRows[$i]);
    }
    return ok;
}

function load( &$base, $whereFields="", $whatFields="*" ) 
{   
    global $applName;
    $query = $base->getSelect();
    if( !$query )
    {
        $typ = $base->getTypeInfo();
        $tableName = $applName."_".get_class($base);
        $firstField = TRUE;
        $query = "SELECT $whatFields FROM $tableName";
        if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
        foreach( $whereFields as $index=>$attribute ) {
            if( !isset($base->{$attribute}) ) unset($whereFields[$index]);
        }
        if( sizeof($whereFields)==0 ) {
            $whereFields = array_keys( $typ["attributes"] );
            foreach( $whereFields as $index=>$attribute ) {
                if(!isset($base->{$attribute})) unset($whereFields[$index]);
            }
        }
        foreach( $whereFields as $key ) {
            if( isset($base->{$key}) ) {
                $value = $base->{$key};
                $value=addcslashes($value,"'\\");
                if( $firstField ) {
                    $query .= " WHERE $tableName.$key='$value'";
                    $firstField = FALSE;
                }
                else $query .= " AND $tableName.$key='$value'";
            }
        }
    }
    $ret = loadSQL( $base, $query );
    return $ret;
}

function create(&$base)
{
    global $whatHappened,$applName;
    global $database;
    
    $base->valid();
    if( $whatHappened=="invalid_form" )
    {
        return ;
    }
    
    $typ = $base->getTypeInfo();
    $className = get_class( $base );
    $query =  "INSERT INTO $applName"."_$className";
    $aia = getAutoIncrementAttribute( $typ );
    $s = getCreateSetStr($base, $typ);
    if( $s!="" ) $query.=" SET $s";

    executeQuery($query);
    // Setting the auto increment key:
    if( $aia )  $base->{$aia} = $database->insertid();
}

function getCreateSetStr($base, $typ , $create=TRUE)
{
    $object_vars = get_object_vars($base);
    $firstField = TRUE;
    $query = "";
    $typ = $base->getTypeInfo();
    foreach( $object_vars as $attribute=>$value )
    {
        if( !in_array("no column", $typ["attributes"][$attribute]) && 
            ($attribute!="creationtime" || !$create) && 
            $attribute!="modificationtime")
        {
            if( !$firstField ) $query .= ", ";
            if( is_array($value) ) // vagy multipleselection, vagy date
            {
                if( ereg("INT", $typ["attributes"][$attribute]["type"])
                    && isset($value["month"]))  // date
                {
                    $h = isset($value["hour"]) ? $value["hour"] : 0;
                    $m = isset($value["minute"]) ? $value["minute"] : 0;
                    $value = mktime($h,$m,0,$value["month"],$value["day"],
                                    $value["year"]);
                    
                }
                elseif(ereg("DATE",
                       $typ["attributes"][$attribute]["type"]))
                {
                    $value = "$value[year]-$value[month]-$value[day]";
                }
                else // multipleselection
                {
                    $value = join( ",", $value );
                }
            }    
            $value=addcslashes($value,"'\\");
            $query .= "$attribute='$value'";
            $firstField = FALSE;
        }
    }
    global $dontSetCreationTime;
    if (isset($typ["attributes"]["creationdatetime"])&&$create&&
        !isset($dontSetCreationTime))
    {
        if( !$firstField ) $query .= ", ";
        $query.="creationdatetime=NOW()";
        $firstField = FALSE;
    }
    if (isset($typ["attributes"]["creationtime"])&&$create&&
        !isset($dontSetCreationTime))
    {
        if( !$firstField ) $query .= ", ";
        $query.="creationtime='".time()."' ";
        $firstField = FALSE;
    }
    if (isset($dontSetCreationTime) && isset($base->creationtime)&&
        $base->creationtime)
    {
        if( !$firstField ) $query .= ", ";
        $query.="creationtime='$base->creationtime' ";
        $firstField = FALSE;
    }
    if (isset($typ["attributes"]["modificationtime"]))
    {
        if( !$firstField ) $query .= ", ";
        $query.="modificationtime='".time()."'";
        $firstField = FALSE;
    }
    return $query;
} 
 
function modify( $base, $whereFields="" )
{
    global $whatHappened,$infoText,$applName;
    
        //TODO: mi van a szopaccsal?
    $ret = $base->valid();
    if( $ret || $whatHappened=="invalid_form" )
    {
        return $ret;
    }
    
    $typ = $base->getTypeInfo();
    $query="UPDATE $applName"."_".get_class($base)." SET ";
    $query .= getCreateSetStr($base, $typ, FALSE);
    $whereExists = FALSE;
    if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
    if( $whereFields )
    {
        $firstField = TRUE;
        foreach( $whereFields as $key )
        {
            if( isset($base->{$key}) )
            {
                $value = $base->{$key};
                $value=addcslashes($value,"'\\");
                if( $firstField )
                {
                    $whereOK=TRUE;
                    $query .= " WHERE $key='$value'";
                    $firstField = FALSE;
                    $whereExists = TRUE;
                }
                else $query .= " AND $key='$value'";
            }
        }
    }
    if (stristr($query,"globalsettings SET")) $whereExists=TRUE;

    if( $whereExists ) executeQuery($query);
    else reportError($query);
    return ok;
}

function delete( $base, $whereFields="" )
{
    global $applName;
    
    if (isset($base->up)) {//recursive delete
        // Ha veletlenul a whereFields nem az id, akkor az id-t be kell
        // tolteni, mert az kell a rekurziv delete-ben:
        if (!isset($base->id)) {
            $ret = $base->load($whereFields);
            if ($ret==not_found_in_db) {
                return $ret;
            }
        }
        getChildrenFromDb($base,$children);
        foreach($children as $child) $child->delete($whereFields);
    }    
    $typ = $base->getTypeInfo();
    $query="DELETE FROM $applName"."_".get_class($base);
    $whereExists = FALSE;
    if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
    if( $whereFields )
    {
        $firstField = TRUE;
        foreach( $whereFields as $key )
        {
            if( isset($base->{$key}) )
            {
                $value = $base->{$key};
                $value=addcslashes($value,"'\\");
                if( $firstField )
                {
                    $query .= " WHERE $key='$value'";
                    $firstField = FALSE;
                    $whereExists = TRUE;
                }
                else $query .= " AND $key='$value'";
            }
        }
    }

    if( $whereExists ) executeQuery($query);
    else reportError($query);
    return ok;
} 

function getPrimaryKey( $typ )
{
    
    if( isset($typ["primary_key"]) )
    {
        $primaryKey = &$typ["primary_key"];
        if( is_array($primaryKey) )
        {
            return $primaryKey;
        }
        elseif( strstr($primaryKey, ",") )
        {
            return split(", *", $primaryKey);
        }
        else
        {
            return array($primaryKey);
        }
    }
    return ok;
}

function getAutoIncrementAttribute( $typ )
{
    foreach( $typ["attributes"] as $attribute=>$attrInfo )
    {
        if( in_array("auto increment", $attrInfo))
        {
            return $attribute;
        }
    }
    return ok;
}
function connectDb($host="",$user="",$pw="",$db="")
{
	return true;
}

function getDbCount( &$count, $query)
{
	global $database;
	
    $database->setQuery($query);
    $count=$database->loadResult();
}
    
function lock($tables)
{
    $query="LOCK TABLES ";
    if (is_string($tables)) $query.=$tables." WRITE";
    else {
        $notfirst=FALSE;
        foreach($tables as $table) {
           if ($notfirst) $query.=",";
           $query.=$table." WRITE";
           $notfirst=TRUE;
        }
    }
    executeQuery($query);
}  
  
function unlock()
{
    executeQuery("UNLOCK TABLES");
} 
   
function getAllColumns( $typ, $tableAlias )
{
    $s = "";
    foreach( $typ["attributes"] as $attr=>$attrInfo )
    {
        if( !in_array("no column", $attrInfo) )
        {
            $s.="$tableAlias.$attr AS $attr, ";
        }
    }
    return $s;
}

function reportError($query)
{
	return;
/*	
    $txt="";
    $txt.="query = $query\n\n";
    $txt.="POST VARS\n";
    foreach($_POST as $key=>$value) {
        $txt.="$key = $value\n";
    }
    $txt.="\n\nGET VARS\n";
    foreach($_GET as $key=>$value) {
        $txt.="$key = $value\n";
    }
    
	if (function_exists( 'debug_backtrace' )) {
		$i = 0;
		foreach( debug_backtrace() as $back) {
			if ($i != 0)
			{
				$txt .= $back['function'] . " " . $back['file'] . " " . $back['line'] . "\n" ;			
			}
			$i++;
		}
	}
    
    mail("error@example.com","Serious error",$txt);
    handleError("A serious error is occured. If you want to help the developers to find this error, send a mail to <a href='mailto:error@example.com'>error@example.com</a> and describe the steps you have made before this error occured. The better your description is, the easier we can find the bug. Thanks.");
 */
}

?>
