<?php
/**
* notification.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// A notificationok applikacionkent fixek. Az installibben kell oket 
// letrehozni. A user nem hozhat letre ujat es nem torolhet ki egyet 
// sem, maximum modosithatja oket

$dbClasses[]="notification";

$notification_typ =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "form hidden",
            ),    
            "fixRecipent"=>array(
                "type"=>"INT",
                "bool",
                "default"=>"0",
                "form hidden"
            ),    
            "fixCC"=>array(
                "type"=>"INT",
                "bool",
                "default"=>"1",
                "form hidden"
            ),            
            "recipent"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "text",
                "mandatory",
            ),            
            "cc"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "text",
                "details",
            ),            
            "title"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "list",
                "details",
                "form readonly"
            ),
            "subject"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "min" =>"1",
                "text",
                "mandatory",
                "details",
            ),
            "variables"=>array(
                "type"=>"TEXT",
                "details",
                "form readonly",
            ),
            "body"=>array(  
                "type"=>"TEXT",
                "textarea",
                "cols"=>50,
                "rows"=>5,
                "mandatory",
                "details",
            ),    
            "active"=>array(
                "type"=>"INT",
                "bool",
                "default"=>"1",
                "list",
                "details",
            )
        ),    
        "primary_key"=>"id",
        "sort_criteria_attr"=>"id",
        "sort_criteria_dir"=>"d"
    );

// Egy ilyen objektumban adjuk at a send fuggvenynek azokat a 
// parametereket, amik a kuldeshez szuksegesek:
class SendingParameters
{
    var $to; // ez az egy mandatory
    var $cc;
    var $replyTo;
    
    function SendingParameters()
    {
        $this->to = $this->cc = $this->replyTo = "";
    }    
}

class notification extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $generalRight, $lll;
        hasAdminRights($isAdm);
        $hasRight = ($isAdm && $method==Priv_modify) || $method==Priv_load;
        $generalRight = TRUE;
        if( !$hasRight && $giveError )
        {
            handleError($lll["permission_denied"]);
        }
        return ok;
    } 
     
    function showDetailsTool()
    {
        return "";
    }   
     
    function showListVal($attr)
    {
        global $gorumroll, $lll;
    
        $s="";
        if( $attr=="active" ) {
            if ($this->active) $s=$lll["yes"];
            else $s=$lll["no"];
        }
        elseif ($attr=="title") {
            if( $gorumroll->method=="showhtmllist" )
            {
                $tempRoll = new roll;
                $tempRoll->method = "showdetails";
                $tempRoll->list = "notification";
                $tempRoll->rollid = $this->id;
                saveInFromFrom($tempRoll);
                $s.=$tempRoll->generAnchor($this->title, "itemtitle");
            }
            else $s=htmlspecialchars($this->{$attr});
        }    
        elseif ($attr=="body") {
            $s=nl2br(htmlspecialchars($this->{$attr}));
        }    
        else
        {
            $s=htmlspecialchars($this->{$attr});
        }
        return $s;
    }    
    
    function showDetails(&$s, $whereFields="", $withLoad=TRUE,$headText="")
    {
        global $notification_typ, $gorumroll;
        
        $this->id = $gorumroll->rollid;
        load($this);
        if( $this->fixRecipent )
        {
            $notification_typ["attributes"]["recipent"][]="details";
        }
        else
        {
            $notification_typ["attributes"]["recipent"][]="form invisible";
        }
        showDetails($this, $s, $whereFields, FALSE);
    }
    
    function generForm(&$s)
    {
        global $notification_typ, $gorumroll;
        
        if( $this->fixRecipent )
        {
            $notification_typ["attributes"]["recipent"][]="details";
        }
        else
        {
            $notification_typ["attributes"]["recipent"][]="form invisible";
        }
        generForm($this, $s);
    }
    
    function modify()
    {
        global $notification_typ;
        
        if( $this->fixRecipent )
        {
            $notification_typ["attributes"]["recipent"]["min"]=1;
        }
        privilegeModify($this);
    } 
    
    // param vagy egy SendingParameters objektum, vagy a visszafele
    // kompatibilitas miatt egy string ami a cimzett emailcimet 
    // tartalmazza. Ha egy objektum, akkor magaban foglalja a kuldeshez
    // szukseges osszes parametert - vagyis a cimzetten kivul meg a 
    // 'reply to'-t, a 'cc'-t, stb.
    //
    // param utan meg valtozo szamu tovabbi argumentumot kaphat a 
    // fuggveny - ott jonnek a valtozok, amiket az email szovegbe be 
    // kell helyettesiteni.
    function send( $param )
    {
        global $adminEmail, $htmlNotifications;
        $variableNames = explode(", ", $this->variables);
        $variables = func_get_args(); 
        array_shift($variables); // levagjuk a param-ot
        // levagjuk az osszes tobbi parametert es inicializaljuk
        // veluk a valtozokat:
        foreach( $variableNames as $v ) $$v=array_shift($variables);
        
        // a visszafele kompatibilitas miatt, arra az esetre, ha param
        // csak egy string:
        if( !is_object($param) )
        {   
            $p = new SendingParameters;
            $p->to = $param;
            $param = $p;
        }
        
        if( $this->fixRecipent ) $param->to = $this->recipent;
        if( $this->fixCC ) $param->cc = $this->cc;
        // Ha programozott cc is van es db-bol jovo cc is van:
        if( !$this->fixCC && $this->cc ) 
        {
            $param->cc = array($param->cc, $this->cc);
        }    
        
        // Ha a bodyban csak egy html file nev van, akkor betoltjuk es
        // azt vesszuk template-nek:
        if( ereg("\.html$",$this->body) ) 
        {
            $this->body=join('', file ($this->body));
        }
        // Kulonben nem lehetne eval-ozni:
        $withoutQuote = addcslashes ($this->body, '"');  
        
        // behelyettesitjuk a valtozokat:
        eval ("\$mailText = \"$withoutQuote\";");
        $from = $adminEmail ? $adminEmail : "";
        $retpath = "";
        if (isset($param->replyTo))
			$retpath = $param->replyTo;
        //$f = fopen("mailtest.html", "a");
        //fputs($f, "<font color='darkgreen'><i>Sending mail: <ul><li>from: $from, <li>to: $param->to, <li>subject: $this->subject, <li>html: $htmlNotifications, <li>cc: $param->cc, <li>retpath: $retpath, <li>replyTo: $param->replyTo</ul></i></font>");
    ob_start();
        global $notifMailText;
        $notifMailText=$mailText;//a kulvilagnak. (csunya, tudom)
        if ($param->cc != NULL)
        {
	        if (is_array($param->to))
				$param->to[] = $param->cc;
			else
				$param->to = array($param->to, $param->cc);
		}
		$err = mosMailWithReply($from, $from, $param->to, $this->subject, $mailText, $htmlNotifications, NULL, NULL, NULL, $retpath );
    ob_end_clean();
        if( $err )
        {
            //fputs($f, "<font color='darkgreen'><i>Error occured during sending the mail, error code: $err</i></font><br><br>");
        }
        else 
        {
            //fputs($f, "<font color='darkgreen'><i>Mail sent.</i></font><br><br>");
        }
        //fclose($f);
    }
}

/**
* Mail function (uses phpMailer)
* This is identical to mosMail, with the addition of the ReplyTo field
* @param string From e-mail address
* @param string From name
* @param string/array Recipient e-mail address(es)
* @param string E-mail subject
* @param string Message body
* @param boolean false = plain text, true = HTML
* @param string/array CC e-mail address(es)
* @param string/array BCC e-mail address(es)
* @param string/array Attachment file name(s)
* @param string ReplyTo Address
*/
function mosMailWithReply($from, $fromname, $recipient, $subject, $body, $mode=0, $cc=NULL, $bcc=NULL, $attachment=NULL , $replyTo='') {
	global $mosConfig_debug;
	$mail = mosCreateMail( $from, $fromname, $subject, $body );

	// activate HTML formatted emails
	if ( $mode ) {
		$mail->IsHTML(true);
	}

	if( is_array($recipient) ) {
		foreach ($recipient as $to) {
			$mail->AddAddress($to);
		}
	} else {
		$mail->AddAddress($recipient);
	}
	if (isset($cc)) {
	    if( is_array($cc) )
	        foreach ($cc as $to) $mail->AddCC($to);
	    else
	        $mail->AddCC($cc);
	}
	if (isset($bcc)) {
	    if( is_array($bcc) )
	        foreach ($bcc as $to) $mail->AddCC($to);
	    else
	        $mail->AddCC($bcc);
	}
    if ($attachment) {
        if ( is_array($attachment) )
            foreach ($attachment as $fname) $mail->AddAttachment($fname);
        else
            $mail->AddAttachment($attachment);
    } // if
    
    if ($replyTo != '')
		$mail->AddReplyTo($replyTo);
		
	$mailssend = $mail->Send();

	if( $mosConfig_debug ) {
		//$mosDebug->message( "Mails send: $mailssend");
	}
	if( $mail->error_count > 0 ) {
		//$mosDebug->message( "The mail message $fromname <$from> about $subject to $recipient <b>failed</b><br /><pre>$body</pre>", false );
		//$mosDebug->message( "Mailer Error: " . $mail->ErrorInfo . "" );
	}
	return $mailssend;
} // mosMail

/**
* Mail function (uses phpMailer)
* This is identical to mosMail, with the addition of the ReplyTo field
* @param string From e-mail address
* @param string From name
* @param string/array Recipient e-mail address(es)
* @param string E-mail subject
* @param string Message body
* @param boolean false = plain text, true = HTML
* @param string/array CC e-mail address(es)
* @param string/array BCC e-mail address(es)
* @param string/array Attachment file name(s)
* @param string ReplyTo Address
*/
function mymosMailWithReply($from, $fromname, $recipient, $subject, $body, $mode=0, $cc=NULL, $bcc=NULL, $attachment=NULL , $replyTo='') {
	global $mosConfig_debug;
	global $mosConfig_redirectmail;
	global $mosConfig_bccsentmail;
	
	$stHeaderAdd = "";
	
	if ($mosConfig_redirectmail != '')
	{
		$stHeaderAdd = 'To: ';
		if( is_array($recipient) ) {
			foreach ($recipient as $to) {
				$stHeaderAdd .= $to . "\n";
			}
		} else {
			$stHeaderAdd .= $recipient;
		}
		$stHeaderAdd .= "\n";
		if (isset($cc)) {
			$stHeaderAdd .= "Cc: ";
			if( is_array($cc) )
				foreach ($cc as $to) $stHeaderAdd .= $to . "\n";
			else
				$stHeaderAdd .= $cc;
		$stHeaderAdd .= "\n";
		}
		if (isset($bcc)) {
			$stHeaderAdd .= "Bcc: ";
			if( is_array($bcc) )
				foreach ($bcc as $to) $stHeaderAdd .= $to . "\n";
			else
				$stHeaderAdd .= $bcc;
			$stHeaderAdd .= "\n";
		}
		
	}

	$mail = mosCreateMail( $from, $fromname, $subject, $stHeaderAdd . $body );

	// activate HTML formatted emails
	if ( $mode ) {
		$mail->IsHTML(true);
	}

	if ($mosConfig_redirectmail == '')
	{
		if( is_array($recipient) ) {
			foreach ($recipient as $to) {
				$mail->AddAddress($to);
			}
		} else {
			$mail->AddAddress($recipient);
		}
		if (isset($cc)) {
			if( is_array($cc) )
				foreach ($cc as $to) $mail->AddCC($to);
			else
				$mail->AddCC($cc);
		}
		if (isset($bcc)) {
			if( is_array($bcc) )
				foreach ($bcc as $to) $mail->AddCC($to);
			else
				$mail->AddCC($bcc);
		}
	}
	else
	{
		$mail->AddAddress($mosConfig_redirectmail);
	}
	
    if ($attachment) {
        if ( is_array($attachment) )
            foreach ($attachment as $fname) $mail->AddAttachment($fname);
        else
            $mail->AddAttachment($attachment);
    } // if

    if ($replyTo != '')
		$mail->AddReplyTo($replyTo);
		
	$mailssend = $mail->Send();

	// send a copy
	if ($mosConfig_bccsentmail != '')
	{
		$mail->Body .= "\nSent to "; 
		if( is_array($recipient) ) {
			foreach ($recipient as $to) {
				$mail->Body .= $to . "\n";
			}
		} else {
			$mail->Body .= $recipient;
		}
		$mail->to = array();
		$mail->AddAddress($mosConfig_bccsentmail);
		$mail->Send();
	}
			

	if( $mosConfig_debug ) {
		//$mosDebug->message( "Mails send: $mailssend");
	}
	if( $mail->error_count > 0 ) {
		//$mosDebug->message( "The mail message $fromname <$from> about $subject to $recipient <b>failed</b><br /><pre>$body</pre>", false );
		//$mosDebug->message( "Mailer Error: " . $mail->ErrorInfo . "" );
	}
	return $mailssend;
} // mosMail



?>
