<?php
/**
* init.php
* @package Noah Classifieds Mambo Component
* @version 1.0
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Don't allow direct access
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


class classifiedsinit extends init
{
function initializeSystemSettings()
{
    global $defaultMethod,$defaultList, $gorumroll, $gorumglobalstat;
    global $user_typ, $withShoppingCart;
    
    init::initializeSystemSettings();
    $gorumglobalstat = new globalstat;
    $gorumglobalstat->id=1;
    $ret=load($gorumglobalstat);
    if ($gorumglobalstat->defPageConf &&
        $gorumroll->method==$defaultMethod &&
        $gorumroll->list==$defaultList)
    {
        $gorumroll->method = "checkconf";
    }
    if( $withShoppingCart )
    {
        $user_typ["attributes"]["viewOrdersLink"][]="list";
        $user_typ["attributes"]["viewOrdersLink"][]="details";
    }
}

function showApp()
{
    global $gorumcontent,$navBarText,$infoText;
    global $upperTemplate,$lowerTemplate,$lll,$xi,$NS4;

    
    $this->makeLoginMenu($loginMenu);    
    $this->makeUserMenu($userMenu);    
    $this->makeAdminMenu($adminMenu);    
    $this->makeClassifMenu($zorumMenu,$loginMenu,$userMenu);

    $userStatus=$this->showUserStatus();
    $userMenuStr=templateShowMenu($zorumMenu);
    $adminMenuStr=templateShowMenu($adminMenu);
    $footer=$this->showVersionFooter();
    if (!$navBarText) $navBarText="";
    $s=templateMain($userMenuStr,$adminMenuStr,$userStatus,
                    $navBarText,$infoText,$gorumcontent,$footer);
    return $s;
}
function showUserStatus()
{
    global $gorumrecognised,$gorumuser,$lll;
    $s="";
    if ($gorumrecognised) {
       $s.=sprintf($lll["loggedas"],htmlspecialchars($gorumuser->name));
    }
    else $s.=$lll["logorreg"];
    return $s;
}
function display( $what )
{    
    global $withShoppingCart, $gorumrecognised, $gorumroll, $categoryClassName;
    global $showChangePassword;
    global $showLogin;
    global $showRegister;
    global $showMyProfile;
    global $showMyAds;
    global $showSubmitAd;
    global $showRecentAds;
    global $showMostPopularAds;
    global $showSearch;
    global $showHome;
    
    hasAdminRights($isAdm);
    switch( $what )
    {
    case Init_adminhelp:
    case Init_confcheck:
        return $isAdm;
    case Init_myCart:
    case Init_trackPurchases:
        return !$isAdm && $gorumrecognised && $withShoppingCart;
    case Init_recentPurchases:
        return $isAdm && $withShoppingCart;
    case Init_search:
        return $showSearch;
    case Init_register:
        return $showRegister && init::display($what);
    case Init_login:
        return $showLogin && init::display($what);
    case Init_myProfile:
        return $showMyProfile && init::display($what);
    case Init_myItems:
        return $showMyAds && init::display($what);    
    case Init_addItem:
        $ret = ($showSubmitAd || $isAdm) && init::display($what);    
        if( $ret )
        {   
            $cat = new $categoryClassName;
            $cat->id = $gorumroll->rollid;
            load($cat, "", "allowAd, accesspost");
            global $my;
            
            if ($my->gid >= $cat->accesspost) {
				$ret = $cat->allowAd;
			} else {
				$ret = false;
			}
        }
        return $ret;
    case Init_recentItems:
        return $showRecentAds && init::display($what);
    case Init_popularItems:
        return $showMostPopularAds && init::display($what);
    case Init_home:
        return $showHome && init::display($what);
    default:
        return init::display($what);           
    }
}
function makeUserMenu(&$menu, $spanCl="")
{
    global $gorumroll,$gorumuser,$lll;
    global $itemClassName, $categoryClassName, $searchClassName, $shoppingCartClassName;

    init::makeUserMenu($menu, $spanCl);

    // Search form:
    if( $this->display( Init_search ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $searchClassName;
        $tempRoll->method = "create_form";   
        $tempRoll->rollid = 0;
        if( $gorumroll->rollid && $gorumroll->list==$itemClassName && 
            $gorumroll->method=="showdetails" )
        {
            $item = new $itemClassName;
            $item->id = $gorumroll->rollid;
            $item->load();
            $tempRoll->cid = $item->cid;
        }            
        else $tempRoll->cid = $gorumroll->rollid;
        saveInFrom($tempRoll);
        $menu[Init_search]=$tempRoll->generAnchor($lll["search"], $spanCl);        
    }
    if( $this->display( Init_myCart ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $shoppingCartClassName;
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = $gorumuser->id;   
        $menu[Init_myCart]=$tempRoll->generAnchor($lll["myCart"], $spanCl);        
    }
    if( $this->display( Init_trackPurchases ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->list = $shoppingCartClassName."_track";
        $tempRoll->method = "showhtmllist";   
        $tempRoll->rollid = $gorumuser->id;   
        $menu[Init_trackPurchases]=$tempRoll->generAnchor($lll["trackPurchases"], $spanCl);        
    }
}
function makeAdminMenu(&$menu, $spanCl="")
{
    global $gorumroll, $lll, $shoppingCartClassName;
    init::makeAdminMenu($menu, $spanCl);

    if( $this->display( Init_adminhelp ))
    {
        $menu[Init_adminhelp]="<a href='http://classifieds.phpoutsourcing.com/faq.php' class='$spanCl'>Ajuda</a>";        
    }
    if( $this->display( Init_confcheck ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->method = "checkconf";
        $menu[Init_confcheck]=
            $tempRoll->generAnchor($lll["Init_confcheck"], $spanCl);
    }
    if( $this->display( Init_recentPurchases ))
    {
        $tempRoll = clone($gorumroll);
        $tempRoll->method = "showhtmllist";
        $tempRoll->list = $shoppingCartClassName."_recent";
        $menu[Init_recentPurchases]=
            $tempRoll->generAnchor($lll["recentPurchases"], $spanCl);
    }
}
function makeClassifMenu(&$menu,$loginMenu,$userMenu)
{
    global $gorumuser, $gorumroll;
    global $gorumauthlevel, $gorumrecognised;
    global $necessaryAuthLevel;
    global $lll;

    //$menu=$loginMenu;

    //$menu[Init_home] = $userMenu[Init_home];
    $menu = array_merge($loginMenu,$userMenu);
}

function generBoxDown()
{
    global $gorumroll, $shoppingCartClassName;
    if( $gorumroll->list==$shoppingCartClassName && $gorumroll->method=="showhtmllist")
    {
        // Ekkor az ShoppingCart::showHtmlList-beli dolgok lepnek ervenybe
        return "";
    }
    return init::generBoxDown();
}


}
?>
